Description

See the screenshot. On the left is v2 spec and on the right is the actual apidoc from foreman v2 api.

Related issues:

Related to Foreman - Bug #4180: V2: The foreman V2 api doesn't support form data Closed 01/24/2014

Related to Foreman - Bug #6248: Some JSON responses are still nested in a roo... Closed 06/17/2014

Related to Foreman - Bug #5178: Users API requires parameters to be wrapped Closed 04/14/2014

History

#1 - 01/24/2014 02:27 PM - Dominic Cleal

- Category set to API

#2 - 04/14/2014 01:41 PM - Adam Price

- Priority changed from Normal to High

#3 - 06/17/2014 10:42 AM - Joseph Magen

David,

The rails default is to return a blank response for PUT and DELETE. Foreman modified the method `api_behavior` in ActionController::Responder to

also return object on PUT and DELETE using the rails code

display resource

See app/controllers/api/api_responder.rb

This code is currently used by all POST, PUT, and DELETE requests.

Note that ONLY GET requests use the RABL templates. Return response of POST, PUT, and DELETE did NOT use RABL.

Since this is just for documentation reasons, I suggest to use the Rails standard as is and to change the documentation accordingly.

In short, PUT/POST/DELETE can receive json with OR without a root, but the response will with WITH root node. However, on the GET, the response

is WITHOUT rootnode since we configured the RABL templates to do so.

#4 - 06/17/2014 11:04 AM - David Davis

- Priority changed from High to Low

Joseph,

First of all, this has nothing to do with what's being returned. This has do with the data that's being sent to create/update. So I'm not sure I understand

the first part of your comment.

Regarding the second part of your comment, the problem is that the api doc (and thus apipie/hammer requests) is not consistent as in certain parts of

the fortello API such as organization, there's no root node whereas other parts of the api such as domain, there is. I think that'll confuse users and

create problems for us developers.
This is only documentation so I don't think it's a high priority. However, the apipie (and thus hammer requests, etc) use this documentation so it

affects the formats of the requests that are being sent to/from katello and foreman. It's caused issues in the past like 

http://projects.theforeman.org/issues/4180 was difficult to solve as only half the requests (the un-nested ones) were failing.

I still think we need this but it's not a high priority.

#5 - 06/17/2014 11:05 AM - David Davis

- Related to Bug #4180: V2: The foreman V2 api doesn't support form data added

#6 - 06/17/2014 11:29 AM - David Davis

- Priority changed from Low to Normal

#7 - 06/18/2014 08:47 AM - Joseph Magen

- Status changed from New to Ready For Testing

- Assignee set to Joseph Magen

- Target version set to 1.8.1

https://github.com/theforeman/foreman/pull/1518

#8 - 06/20/2014 08:56 AM - Dominic Cleal

- Subject changed from V2: Api docs in foreman should not require a root node for POST/PUT to V2: Api docs in foreman should not specify a root

node for POST/PUT

- Status changed from Ready For Testing to New

- Assignee deleted (Joseph Magen)

- Target version deleted (1.8.1)

Resetting this, because the pull request mentioned changes the response from the API and doesn't change the documentation, as David said.  The

apipie description of the APIv2 actions includes a wrapped node, which in Foreman's API is optional and as per the documentation (in the screenshot

provided) is not used.

#9 - 06/24/2014 08:25 AM - Dominic Cleal

- Related to Bug #6248: Some JSON responses are still nested in a root node added

#10 - 06/24/2014 08:25 AM - Dominic Cleal

- Related to Bug #5178: Users API requires parameters to be wrapped added

#11 - 07/18/2014 12:05 PM - David Davis

- Status changed from New to Assigned

- Assignee set to David Davis

#12 - 07/20/2014 05:17 AM - Joseph Magen

- Assignee changed from David Davis to Joseph Magen

- Target version set to 1.8.0

#13 - 07/24/2014 07:29 AM - The Foreman Bot

- Status changed from Assigned to Ready For Testing

- Pull request https://github.com/theforeman/foreman/pull/1601 added

- Pull request deleted ()

#14 - 07/30/2014 06:48 AM - Anonymous

- Target version changed from 1.8.0 to 1.7.5

#15 - 07/31/2014 05:24 PM - David Davis

I think we can close this out.

#16 - 08/01/2014 02:31 AM - Dominic Cleal

Why?
#17 - 08/01/2014 08:28 AM - David Davis

I thought from our conversation yesterday we were just leaving the API as is basically and fixing bugs?

#18 - 08/07/2014 04:34 PM - Joseph Magen

- Status changed from Ready For Testing to Closed

it was decided to keep api V2 POST/PUT as wrapped parameters

#19 - 08/08/2014 03:53 AM - Dominic Cleal

- Status changed from Closed to Rejected

- Target version deleted (1.7.5)
